// This software including the source code and documentation (the "SOFTWARE")
// is copyrighted.  You are free to use the SOFTWARE for any non-commercial
// purpose whatsoever provided you do not remove this copyright notice.
// If you wish to use the SOFTWARE for commercial purposes, please contact us
// to obtain a license.  The SOFTWARE is provided "as is", with absolutely no
// warranty.  Use it at your own risk.
// Website: http://www.math.ie/checker.html

// from unav36.exe
// written by Guenter Stertenbrink, sterten@aol.com
// Website: http://magictour.free.fr/sudoku.htm

// find all unavoidables concentrated in one of the 6 chutes or 84 3-rookeries
// or 9  subsquares of 2*2 blocks
// tested with sf : 639241785284765193517983624123857946796432851458619237342178569861594372975326418

#include <stdio.h>
#include <vector>
#include <algorithm>
#include "myset.h"
#include "unav36.h"
using namespace std;

static int Rows[7325],Cols[730],Row[7325][82],Col[730][7785],Ur[8730],Uc[8325],V[8325];
static int U[88],S[9999][88],Node[88],A[88],G[88],C[88],I[88],H[88];
static unsigned long long Sy[9999],lx,ly,li,lj;
static int M[10]={0,1,1,1,2,2,2,3,3,3};
static char B[83]="0111222333111222333111222333444555666444555666444555666777888999777888999777888999";
static int Ua[9999][66],UB[9999],UA[9999],Q[8888],g[82][8888],v[82][8888];
static int q,l,x1,f1,f2,f3,f4,k,u,b,a,i,j,r,c,d,n=729,m=324,x,y,s,ua;
static int kurz,nz=0,size,r1,fi,z,nodes,solutions,clues,maxsize;
static char L[99]=".123456789";
static FILE *file;

static int solve();
static void unav27();
static void unav36();


void GFindUnavoidableSets_unav36( int GG[ 82 ], vector< MySet >& sets )
   {
   int y1;
   memcpy( G, GG, 82 * sizeof( int ) );
   r=0;for(x=1;x<=9;x++)for(y=1;y<=9;y++)for(s=1;s<=9;s++){
   r++;Cols[r]=4;Col[r][1]=x*9-9+y;Col[r][2]=(B[x*9-9+y]-48)*9-9+s+81;
   Col[r][3]=x*9-9+s+81*2;Col[r][4]=y*9-9+s+81*3;}
   for(c=1;c<=m;c++)Rows[c]=0;
   for(r=1;r<=n;r++)for(c=1;c<=Cols[r];c++){
   a=Col[r][c];Rows[a]++;Row[a][Rows[a]]=r;}

   ua=0;
   for(i=1;i<=27;i++)H[i]=i;unav27();
   for(i=1;i<=27;i++)H[i]=i+27;unav27();
   for(i=1;i<=27;i++)H[i]=i+54;unav27();
   i=0;for(x=1;x<=9;x++)for(y=1;y<=3;y++){i++;H[i]=x*9-9+y;}unav27();
   i=0;for(x=1;x<=9;x++)for(y=4;y<=6;y++){i++;H[i]=x*9-9+y;}unav27();
   i=0;for(x=1;x<=9;x++)for(y=7;y<=9;y++){i++;H[i]=x*9-9+y;}unav27();

   for(f1=1;f1<=9;f1++)for(f2=f1+1;f2<=9;f2++)for(f3=f2+1;f3<=9;f3++)
      {
      k=0;for(i=1;i<=81;i++)if(G[i]==f1 || G[i]==f2 || G[i]==f3){k++;H[k]=i;}
      unav27();
      }

   for(x1=1;x1<=3;x1++)for(y1=1;y1<=3;y1++)
      {
      i=0;
      for(x=1;x<=9;x++)for(y=1;y<=9;y++)if(M[x]!=x1 && M[y]!=y1){i++;H[i]=x*9-9+y;}
      unav36();
      }
   
   f3=0;
   int cSets = 0;
   for(f1=1;f1<=ua;f1++)
      {
      for(i=1;i<=81;i++)
         V[i]=0;
      for(i=1;i<=UA[f1];i++)
         V[Ua[f1][i]]=1;
      for(f2=1;f2<=ua;f2++)
         {
         q=0;
         for(i=1;i<=UA[f2];i++)
            q+=V[Ua[f2][i]];
         if(q==UA[f2] && UA[f2]<UA[f1])
            goto m41;
         if(q==UA[f2] && f1<f2 && UA[f2]==UA[f1])
            goto m41;
         }
      k=9;
      f3++;
      UB[f3]=f1;
      // use unavoidable sets of size 8-14
      if ( UA[ f1 ] >= 8  &&  UA[ f1 ] <= 14 )
         {
         MySet set( false );
         for ( i=1; i<=UA[f1]; i++ )
            set.AddElement( (Ua[f1][i]-1)/k, (Ua[f1][i]-1)%k );
         set.Sort();
         sets.push_back( set );
         cSets++;
         }
m41:
      0;
      }
   }

//-----------------------------------------------------------------------
static int solve(){// makes solution grids S[1..solutions][1..81]
int i,r,j,d,k,c,m0,m1,min,c1,c2,l;

   for(i=0;i<=n;i++)Ur[i]=0;for(i=0;i<=m;i++)Uc[i]=0;
   clues=0;for(i=1;i<=81;i++)
     if(A[i]){clues++;r=i*9-9+A[i];
       for(j=1;j<=Cols[r];j++){d=Col[r][j];if(Uc[d])return 0;Uc[d]++;
         for(k=1;k<=Rows[d];k++){Ur[Row[d][k]]++;}}}
   for(c=1;c<=m;c++){V[c]=0;for(r=1;r<=Rows[c];r++)if(Ur[Row[c][r]]==0)V[c]++;}

   i=clues;m0=0;m1=0;solutions=0;nodes=0;
m2:i++;I[i]=0;min=n+1;if(i>81 || m0)goto m4;
   if(m1){C[i]=m1;goto m3;}
   for(c=1;c<=m;c++)if(!Uc[c]) { if(V[c]<2){C[i]=c;goto m3;}
          if(V[c]<min){C[i]=c;min=V[c];} }

m3:c=C[i];I[i]++;if(I[i]>Rows[c])goto m4;
   r=Row[c][I[i]];if(Ur[r])goto m3;m0=0;m1=0;
   nodes++;
   for(j=1;j<=Cols[r];j++){c1=Col[r][j];Uc[c1]++;}
   for(j=1;j<=Cols[r];j++){c1=Col[r][j];
      for(k=1;k<=Rows[c1];k++){r1=Row[c1][k];Ur[r1]++;if(Ur[r1]==1)
         for(l=1;l<=Cols[r1];l++){c2=Col[r1][l];V[c2]--;
            if(Uc[c2]+V[c2]<1)m0=c2;if(Uc[c2]==0 && V[c2]<2)m1=c2;}}}

k=9;A[(r-1)/k+1]=(r-1)%k+1;

   if(i==81){solutions++;for(j=1;j<=81;j++)S[solutions][j]=A[j];}
if(solutions>9998){return solutions;}
   goto m2;
m4:i--;c=C[i];r=Row[c][I[i]];if(i==clues)goto m9;

   for(j=1;j<=Cols[r];j++){c1=Col[r][j];Uc[c1]--;
      for(k=1;k<=Rows[c1];k++){r1=Row[c1][k];Ur[r1]--;
         if(Ur[r1]==0)for(l=1;l<=Cols[r1];l++){c2=Col[r1][l];V[c2]++;}}}
   if(i>clues)goto m3;
m9:return solutions;}


static void unav27(){
for(i=1;i<=81;i++)A[i]=G[i];for(i=1;i<=27;i++)A[H[i]]=0;
solve();
for(x=1;x<=solutions;x++){y=0;
   for(i=1;i<=27;i++)if(S[x][H[i]]!=G[H[i]])y+=(1<<i);Sy[x]=y;}
for(x=1;x<=solutions;x++){
   q=0;for(y=1;y<=solutions;y++){
         if((Sy[x]&Sy[y])==Sy[y] && Sy[x]!=Sy[y] && Sy[x]>0 && Sy[y]>0)q++;
         if((Sy[x]&Sy[y])==Sy[y] && Sy[x]==Sy[y] && Sy[x]>0 && y<x)q++;}
   if(Sy[x]>0 && q==0){ua++;l=0;
     for(i=1;i<=27;i++)if(S[x][H[i]]!=G[H[i]]){l++;Ua[ua][l]=H[i];}UA[ua]=l;}}}


static void unav36(){
for(i=1;i<=81;i++)A[i]=G[i];for(i=1;i<=36;i++)A[H[i]]=0;
solve();
for(x=1;x<=solutions;x++){Sy[x]=0;
   for(i=1;i<=36;i++){li=1;lj=i;if(S[x][H[i]]!=G[H[i]])Sy[x]+=(li<<lj);}}
for(x=1;x<=solutions;x++){q=0;
   for(y=1;y<=solutions;y++){
      if((Sy[x]&Sy[y])==Sy[y] && Sy[x]!=Sy[y] && Sy[x]>0 && Sy[y]>0)q++;
      if((Sy[x]&Sy[y])==Sy[y] && Sy[x]==Sy[y] && Sy[x]>0 && y<x)q++;}
   if(Sy[x]>0 && q==0){ua++;l=0;
     for(i=1;i<=36;i++)if(S[x][H[i]]!=G[H[i]]){l++;Ua[ua][l]=H[i];}UA[ua]=l;}}}
